Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.websocket
Class WsInputStream

    java.lang.Object
      java.io.InputStream
          org.apache.catalina.websocket.WsInputStream

All Implemented Interfaces:
  Closeable

    public class WsInputStream

extends InputStream

This class is used to read WebSocket frames from the underlying socket and makes the payload available for reading as an `InputStream`. It only makes the number of bytes declared in the payload length available for reading even if more bytes are available from the socket.

Constructor Summary
`WsInputStream(UpgradeProcessor<?> processor, WsOutbound outbound)`

Method Summary
`WsFrame` | `nextFrame(boolean block)` Process the next WebSocket frame.
`int` | `read()`
`int` | `read(byte[] b, int off, int len)`

Methods inherited from class java.io.InputStream
`available, close, mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### WsInputStream

    public WsInputStream(UpgradeProcessor<?> processor,
                         WsOutbound outbound)

Method Detail

### nextFrame

    public WsFrame nextFrame(boolean block)
                      throws IOException

  Process the next WebSocket frame.

  Parameters:
    `block` - Should this method block until a frame is presented if no data is currently available to process. Note that if a single byte is available, this method will block until the complete frame (excluding payload for non-control frames) is available.
  Returns:
    The next frame to be processed or `null` if block is `false` and there is no data to be processed.
  Throws:
    `IOException` - If a problem occurs reading the data for the frame.

### read

    public int read()
             throws IOException

  Specified by:
    `read` in class `InputStream`
  Throws:
    `IOException`

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Overrides:
    `read` in class `InputStream`
  Throws:
    `IOException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2012 Apache Software Foundation. All Rights Reserved.